'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
'                    PC FAN Controler Soft for ATmega
'
'                                  Rev.4.81 for mega168
'
'                                                    2010.11 by T.Sugiyama
'
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
' F4.81  t@ċN̋蓮ݒł悤ɕύX
'
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'$sim

$regfile = "m168def.dat"
$crystal = 16000000
$hwstack = 64
$swstack = 64
$framesize = 64

$baud = 9600

'---------------------------------------------------------------------------------
'          Rev4.0̐ݒ
'---------------------------------------------------------------------------------
Const Firm_Version = "F4.81"    't@[o[W
Const FAN_Max = 6              't@ڑ䐔i]ZT̐j
Const PWM_Max = 4              't@CHiPWM`lj
Const THM_Max = 4              'xv䐔

'FANoPin(PWM)
FAN1out Alias Pinb.2  'FAN#1 PWM Pin
FAN2out Alias Pinb.1  'FAN#2 PWM Pin
FAN3out Alias Pind.6  'FAN#3 PWM Pin
FAN4out Alias Pind.5  'FAN#4 PWM Pin

'PWM Duty
FAN1PWM Alias PWM1B   'FAN#1 PWM Duty
FAN2PWM Alias PWM1A   'FAN#2 PWM Duty
FAN3PWM Alias Pwm0a   'FAN#3 PWM Duty
FAN4PWM Alias Pwm0b   'FAN#4 PWM Duty
FAN5PWM Alias Pwm0a   'FAN#5 PWM Duty
FAN6PWM Alias Pwm0b   'FAN#6 PWM Duty

'FAN]pX
FAN1sens Alias Pind.4 'FAN#1 Speed Sensor
FAN2sens Alias PinC.1 'FAN#2 Speed Sensor
FAN3sens Alias Pind.3 'FAN#3 Speed Sensor
FAN4sens Alias Pinb.0 'FAN#4 Speed Sensor
FAN5sens Alias Pind.2 'FAN#5 Speed Sensor
FAN6sens Alias Pind.7 'FAN#6 Speed Sensor

'FAN]pX}XN
Dim Pmask0( 6 ) As Byte
Dim Pmask1( 6 ) As Byte
Dim Pmask2( 6 ) As Byte
Pmask0(1)=0 : Pmask1(1)=0 : Pmask2(1)=&B00010000 'FAN#1 Speed Sensor Mask
Pmask0(2)=0 : Pmask1(2)=&B00000010 : Pmask2(2)=0 'FAN#2 Speed Sensor Mask
Pmask0(3)=0 : Pmask1(3)=0 : Pmask2(3)=&B00001000 'FAN#3 Speed Sensor Mask
Pmask0(4)=&B00000001 : Pmask1(4)=0 : Pmask2(4)=0 'FAN#4 Speed Sensor Mask
Pmask0(5)=0 : Pmask1(5)=0 : Pmask2(5)=&B00000100 'FAN#5 Speed Sensor Mask
Pmask0(6)=0 : Pmask1(6)=0 : Pmask2(6)=&B10000000 'FAN#6 Speed Sensor Mask

'xvADC`l
Dim ADC_Thm( 4 ) As  Byte
ADC_Thm(1)=5 : ADC_Thm(2)=4 : ADC_Thm(3)=3 : ADC_Thm(4)=2

'AUX output Port
AUXPort Alias PortC.0

'|[g̃vAbv
PortB=&B00111001
PortC=&B00000010
PortD=&B10011100

' AVR pin assign
'
'  1: RESET         : ISP Reset
'  2: PD0(RxD)      : Serial UART
'  3: PD1(TxD)      : Serial UART
'  4: PD2(PCINT18)  : FAN#5 Speed Sensor
'  5: PD3(PCINT19)  : FAN#3 Speed Sensor
'  6: PD4(PCINT20)  : FAN#1 Speed Sensor
'  7: Vcc
'  8: GND
'  9: XTAL1
' 10: XTAL2
' 11: PD5(OC0B)     : FAN#4 PWM
' 12: PD6(OC0A)     : FAN#3 PWM
' 13: PD7(PCINT23)  : FAN#6 Speed Sensor
' 14: PB0(PCINT0)   : FAN#4 Speed Sensor
' 15: PB1(OC1A)     : FAN#2 PWM
' 16: PB2(OC1B)     : FAN#1 PWM
' 17: PB3(MOSI)     : ISP MOSI
' 18: PB4(MISO)     : ISP MISO
' 19: PB5(SCK)      : ISP SCK
' 20: AVcc
' 21: Aref
' 22: AGND
' 23: PC0           : NC
' 24: PC1(PCINT9)   : FAN#2 Speed Sensor
' 25: PC2(ADC2)     : Thermistor#4
' 26: PC3(ADC3)     : Thermistor#3
' 27: PC4(ADC4)     : Thermistor#2
' 28: PC5(ADC5)     : Thermistor#1

'---------------------------------------------------------------------------------
'         e錾
'---------------------------------------------------------------------------------

'PINݒ
Config FAN1out = Output     'FAN#1 PWM
Config FAN2out = Output     'FAN#2 PWM
Config FAN3out = Output     'FAN#3 PWM
Config FAN4out = Output     'FAN#4 PWM

Config FAN1Sens = Input     'FAN#1 Speed Sensor
Config FAN2sens = Input     'FAN#2 Speed Sensor
Config FAN3sens = Input     'FAN#3 Speed Sensor
Config FAN4sens = Input     'FAN#4 Speed Sensor
Config FAN5sens = Input     'FAN#5 Speed Sensor
Config FAN6sens = Input     'FAN#6 Speed Sensor

Config AUXPort = Output     'AUX Port (Fan4-2̖O"off"̂ƂLow)

'`cRo[^ݒ
Config Adc = Single , Prescaler = Auto , Reference = AVCC

'ovlݒ
'  prescale= 1,8,64,256,1024   clear timer= 0;Phase Correct PWM Mode, 1;Fast PWM Mode
Config Timer1 = Pwm , Prescale = 1 , Clear Timer = 0 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down , Pwm = 8
Config Timer0 = Pwm , Prescale = 1 , Clear Timer = 0 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down

'^C}[уt@ZT[݂̐ݒ
'  i]vɎgpj
Config Timer2 = Timer , Prescale = 1024
On Timer2 Tmr2_int nosave
On Pcint0 Pci_int nosave
On Pcint1 Pci_int nosave
On pcint2 Pci_int nosave

'VA|[g̐ݒ
Config Serialin = Buffered , Size = 250

'ϐ錾

'e|ϐ
Dim Igr0 As Integer
Dim Igr1 As Integer
Dim Igr2 As Integer
Dim Igr3 As Integer
Dim Igr4 As Integer

Dim Sgl0 As Single
Dim Sgl1 As Single
Dim Sgl2 As Single
Dim Sgl3 As Single
Dim Sgl4 As Single

Dim Str1 As String * 10
Dim Str2 As String * 10
Dim Str3 As String * 10

'ϐ
Dim USB_data As String * 128
Dim StrArray(8) As string * 7

'`lIpϐ
Dim Thm_chan As Byte    'T[~X^
Dim Fan_chan As Byte    't@
Dim Adc_chan As Byte    '`cRo[^

'pϐ
Dim Ratio As Word       'T[~X^di0`1023j
Dim Tmpr  As Single     'xij
Dim Chan  As Byte       '`l


'PWM Dutyݒ萔Eϐ
Const Pmax = 255     'ovl̐ݒől
Dim PWM_duty( 6 )   As Integer     'ovl̐ݒ萔i0`255j

']vp萔Eϐ
Const Tmr_clock  = 16000.0    'As Single   '16000kHz=CPU Clock (kHz)
Const Tmr_cycle  = 0.064      'As Single   '=1024/Tmr_clock (ms), prescale=1024
Const Tmr_over  =16.384       'As Single   '= Tmr_cycle*256,Timer2 Overflow time (ms) (8bit(256) Timer)
Const Tmr_over_cnt_max  = 30  'As Byte     'v=Tmr_over_cnt_max*Tmr_over=491.52ms,Timer2 Time Out Count
Const Tmr_over_cnt_max2 = 12  'As Byte     'v=Tmr_over_cnt_max*Tmr_over=196.61ms,Timer2 Time Out Count
Const Fan_puls_min_wdth =2.0  'As Single   'ŏpX=2ms

Dim Tmr_max           As Integer   'Timer2 Overflow Count Max
Dim Tmr_over_cnt      As Byte      'Timer2 Overflow Count
Dim Tmr_over_cnt_arg  As Byte      'Timer2 Overflow Count Argument
Dim Tmr_cnt_arg       As Byte      'Timer2 Count Argument
Dim Fan_cnt_time      As Single    'Fan Counted Time (ms)
Dim Fan_cnt           As Integer   'Fan Pulse Counter
Dim Fan_stop_flag     As Integer   'All Fan Stop flag (0:Stop)
Dim Pci_flag          As Byte      'PCINT interrupt flag

'vʊi[pϐ
Dim Temper( 4 )      As Single      'xij
Dim Duty_rto( 6 )    As Single      'ovl̃f[eBij
Dim Tach( 6 )        As Integer     ']ij
Dim Fan_status( 6 )  As Integer     'Dutyp]
Dim Fan_tach         As Integer

't@R萔і́iEEPROMɊi[j
Dim Tmin( 4 )      As ERAM Integer  at   0 'DminƂȂ鉷xij
Dim Tmax( 4 )      As ERAM Integer  at   8 'DmaxƂȂ鉷xij
Dim Dmin( 4 )      As ERAM Integer  at  16 'Tminł̃f[eBij
Dim Dmax( 4 )      As ERAM Integer  at  24 'Tmaxł̃f[eBij
Dim FanThm( 4 )    As ERAM Integer  at  32 't@𐧌䂷鉷xvԍ
Dim Fanname( 6 )   As ERAM String*6 at  40 't@
Dim Thmname( 4 )   As ERAM String*6 at  82 'xv
Dim Tstop( 4 )     As ERAM Integer  at 110 'Fan~xij
Dim FanMan( 6 )    As ERAM Integer  at 118 't@@1:蓮@0:
Dim Dman( 6 )      As ERAM Integer  at 130 '蓮̃f[eBij

'FAN~@\pϐ
Dim Stp_flag( 6 )  As Byte                 'Fan~tO(1:~,0:N)
Stp_flag(1) = 0 : Stp_flag(2) = 0 : Stp_flag(3) = 0
Stp_flag(4) = 0 : Stp_flag(5) = 0 : Stp_flag(6) = 0

'O։xpϐ
Dim ExtTemper( 4 )  As Single      'O͉xij
Dim Ext_Eff_cnt     As Integer     'O։x̎cLi^[j
Const Ext_Eff_cnt_max = 5           'L̍őli^[j
Ext_Eff_cnt = 0

'eXg[hpϐ
Const Test_Max = 300
Dim   Test_cnt As  Integer

'Tu[`ъ֐錾

'VA|[go͗pTu[`
Declare Sub RcvMsg( )
Declare Sub SndPrm( )
Declare Sub WrtPrm( )

'FAN PWMݒpTu[`
Declare Sub Set_Speed( Fan_chan As Byte )
Declare Sub Set_Speed_full( )

Declare Function Temperature( Ratio As Word ) As Single
Declare Function Duty( Chan As Byte , Tmpr As Single ) As Integer
Declare Function Fanspeed( Chan AS Byte ) AS Integer
Declare Function Tmrpass( ) As Single

'pt@NV
Declare Function Name_Str( Cliped_Str As String ) As String
Declare Function Tach_Str( Tach_Igr As Integer )  As String
Declare Function Temp_Str( Temp_Sgl As Single )  As String
Declare Function Duty_Str( Duty_Sgl As Single )  As String

'Test Mode Tu[`
Declare Sub TestMode( Fan_chan As Byte )

'----------------------------------- Main Routine --------------------------------
'N@tXs[h 3Sec

Call Set_Speed_Full( )

Enable Interrupts

'[v
Do

'  x
   For Thm_chan = 1 To THM_Max

      Adc_chan = ADC_Thm( Thm_chan )
      Start Adc
      Ratio = Getadc( Adc_chan )
      Stop Adc
      Temper( Thm_chan ) = Temperature( Ratio )

      'O։xgp
      If Ext_Eff_cnt > 0 Then
         If ExtTemper( Thm_chan ) > 5.0 Then
            Temper( Thm_chan ) = ExtTemper( Thm_chan )
         Endif
      Endif

      Sgl1 = Temper( Thm_chan )  : Str1 = Temp_Str( Sgl1 )
      Str2 = Thmname( Thm_chan ) : Str2 = Name_Str( Str2 )
      Print "Thm ," ; Thm_chan ; "," ; Str2  ; "," ; Str1

   Next Thm_chan

'   Print

   If Ext_Eff_cnt > 0 Then
      Ext_Eff_cnt = Ext_Eff_cnt - 1
   Else
      Ext_Eff_cnt = 0
   Endif

'  f[eBݒ

   For Fan_chan = 1 To PWM_Max

      Chan = FanThm( Fan_chan )
      Tmpr = Temper( Chan )
      Igr1 = Duty( Fan_chan , Tmpr )
      PWM_duty( Fan_chan ) = Igr1

'     Fan~̏iڑ܂PC~zj
'        Y`lAݒ(FanMan=0)rA~(Fan_status=0)Aቷɂ~łȂ(Stp_flag=0)
'        ̎́AċNɔDutyDmani蓮ݒljƂĂB
'        ADman=0͉̎sȂBi2sFanΉj
      If FanMan(Fan_chan) = 0 Then
         If Fan_status( Fan_chan ) = 0 Then
            If Stp_flag( Fan_chan ) = 0 Then
               If Dman( Fan_chan ) > 0 Then
                  Igr1 = Pmax
                  Igr1 = Igr1 * Dman( Fan_chan )
                  PWM_duty( Fan_chan ) = Igr1 / 100
               Endif
            Endif
         Endif
      Endif

      Call Set_Speed( Fan_chan )

   Next Fan_chan

   Igr1 = Fan_Max-PWM_Max
   If Igr1<>0 then
      Duty_rto( 5 ) = Duty_rto( 3 )
      Duty_rto( 6 ) = Duty_rto( 4 )
      Stp_flag( 5 ) = Stp_flag( 3 )
      Stp_flag( 6 ) = Stp_flag( 4 )
   Else
      Waitms 1000
   Endif

'@]

   For Fan_chan = 1 TO FAN_Max

      Tmr_max = Tmr_over_cnt_max
      Fan_Tach = Fanspeed( Fan_chan )

'     ]OɂȂ̏
'        Y`lAݒ(FanMan=0)Aቷɂ~łȂ(Stp_flag=0)
'        ̎́ADuty100%ōċNB
'        ADman=0͉̎sȂBi2sFanΉj

      If Fan_Tach = 0 Then
         If FanMan(Fan_chan) = 0 Then
            If Stp_flag( Fan_chan ) = 0 Then
               If Dman( Fan_chan ) > 0 Then
                  If PWM_duty( Fan_chan ) >0 Then
                     PWM_duty( Fan_chan ) =  Pmax
                     Call Set_Speed( Fan_chan )
                     Fan_Tach = Fanspeed( Fan_chan )
                  Endif
               Endif
            Endif
         Endif
      Endif

      Tach( Fan_chan ) = Fan_Tach
      Fan_status( Fan_chan ) = Fan_Tach
      Str1 = Tach_Str( Fan_Tach )
      Sgl1 = Duty_rto( Fan_chan ) : Str2 = Duty_Str( Sgl1 )
      Str3 = Fanname( Fan_chan )  : Str3 = Name_Str( Str3 )
      Print "Fan," ; Fan_chan ; "," ; Str3 ; "," ; Str1 ; "," ; Str2

   Next Fan_chan

   Igr1 = Fan_Max-PWM_Max
   If Igr1<>0 then
      Fan_status( 3 ) = Fan_status( 3 ) + Fan_status( 5 )
      Fan_status( 4 ) = Fan_status( 4 ) + Fan_status( 6 )
   Else
      For Fan_chan = 5 to 6
         Str3 = Fanname( Fan_chan )
         Print "Fan," ; Fan_chan ;"," ; Str3 ; ",0, 0.0"
      Next Fan_chan
   Endif

   Call RcvMsg()

   Call SndPrm()

   'AUX PortC0 Fan4-2̖O"off"̂ƂLow
   Str1=Fanname( 6 )
   If Trim( Str1 ) = "off" Then
      Reset  AUXPort
   Else
      Set  AUXPort
   Endif

Loop

End

$eeprom
$eepromhex

Tmindata:
   Data   35% ,  35% ,  35% ,  35%
Tmaxdata:
   Data   55% ,  55% ,  55% ,  55%
Dmindata:
   Data   30% ,  30% ,  30% ,  30%
Dmaxdata:
   Data  100% , 100% , 100% , 100%
FanThm:
   Data    1% ,   2% ,   3% ,   4%
Fanname:
   Data "CPU   ","Power ","Rear1 ","Front1","Rear2 ","Front2"
Thmname:
   Data "CPU   ","Power ","HDD   ","Intake"
Tstopdata:
   Data  -50% , -50% ,  30% ,  30%
FanMan:
   Data 0% , 0% , 0% , 0% , 0% , 0%
Dmandata:
   Data 100% , 100% , 100% , 100% , 100% , 100%

$data


'***********************************************************
'ʃ`l̃f[eB[ݒ

Sub Set_Speed( Fan_chan As Byte )

   Local iDuty As Integer
   Local sDuty As Single

   iDuty = PWM_duty( Fan_chan )
   Select Case Fan_chan
      Case 1 : FAN1PWM = iDuty
      Case 2 : FAN2PWM = iDuty
      Case 3 : FAN3PWM = iDuty
      Case 4 : FAN4PWM = iDuty
      Case 5 : FAN5PWM = iDuty
      Case 6 : FAN6PWM = iDuty
   End Select

   sDuty = PWM_duty( Fan_chan ) / Pmax
   Duty_rto( Fan_chan ) = sDuty * 100

End Sub

'***********************************************************
'S`lS

Sub Set_Speed_full( )

   FAN1PWM = Pmax
   FAN2PWM = Pmax
   FAN3PWM = Pmax
   FAN4PWM = Pmax
   Waitms 3000

End Sub

'***********************************************************
'T[~X^̓d牷xvZ֐

Function Temperature( Ratio As Word ) As Single
   'Temperature : xij
   'ratio       : T[~X^di0`1023j

   Local X As Single
   Local Y As Single

   X = Ratio
   Y = 1023.0 - X

   If Y <= 1.0 Then
      Temperature = -20.0
   Elseif Y >= 1022.0 Then
      Temperature = 999.0
   Else
      Y = X / Y
      X = Log(Y)
      Y = 0.29112 * X
      X = Y + 3.1359
      Y = 1000.0 / X
      Temperature = Y - 273.0
   End If

End Function

'***********************************************************
'T[~X^̉xFanDutyvZ֐

Function Duty( Fan_chan As Byte , Tmpr As Single ) As Integer
   'Fan_chan :  FAN Channel
   'Tmpr     :  xij
   'Duty     :  0`255

   Local F As Byte

   Local D As Single

   Local W As Single
   Local X As Single
   Local Y As Single
   Local Z As Single

   If FanMan( Fan_chan ) = 1 Then     '蓮ݒ莞
      Igr1 = Dman( Fan_chan )
      D = Igr1
      D = D * Pmax
      D = D * 0.01
      Duty = Int( D )
      Stp_flag( Fan_chan ) = 0
      Exit Sub
   Endif

   Igr0 = Tstop( Fan_chan )
   Sgl0 = Igr0                  'Sgl0 = Tstop

   Igr1 = Tmin( Fan_chan )
   Sgl1 = Igr1                  'Sgl1 = Tmin

   Igr2 = Tmax( Fan_chan )
   Sgl2 = Igr2                  'Sgl2 = Tmax

   Igr3 = Dmin( Fan_chan )
   Sgl3 = Igr3                  'Sgl3 = Dmin

   Igr4 = Dmax( Fan_chan )
   Sgl4 = Igr4                  'Sgl4 = Dmax

   F = Stp_flag( Fan_chan )
   If Tmpr <= Sgl0 Then        'xTstopȉ̂Ƃ͒~
      F = 1
      D = 0.0
   Elseif Tmpr <= Sgl1 Then   'xTminȉ̂Ƃ
      If F = 1 Then            '~ԂȂ~p
         D = 0.0
      Else                     'ԂȂDminœ
         D = Sgl3
      Endif
   Elseif Tmpr => Sgl2 Then   'xTmaxȏ̂ƂDmaxœ
      D = Sgl4
      F = 0
   Else                        'xTminȏATmaxȉ̂Ƃ
      If F = 0 Then
         W = Tmpr - Sgl1      'W=Tmpr-Tmin (deg)
         X = Sgl4 - Sgl3      'X=Dmax-Dmin (%)
         Y = Sgl2 - Sgl1      'Y=Tmax-Tmin (deg)
         Z = X / Y            'Z:Slope     (%/deg)
         Y = Z * W            'Y=slope*(Tmpr-Tmin)  (%)
         D = Y + Sgl3         'D=Y+Dmin    (%)
      Else                    '~ԂN
         Igr1 = Dman( Fan_chan )
         D = Igr1
         F = 0
      Endif
   End If

   D = D * Pmax
   D = D * 0.01
   Duty = Round( D )

   Stp_flag( Fan_chan ) = F

End Function

'***********************************************************
'Fan̉]vvZ֐

Function Fanspeed( Fan_chan As Byte ) As Integer
   'Fan_chan   :  FAN Channel

   Local X As Single

   Fan_cnt = 0
   Fan_cnt_time = 0.0
   Tmr_over_cnt = 0
   Timer2 = 0

   PCMSK0 = Pmask0( Fan_chan ) : If PCMSK0 <>0 Then Enable PCINT0
   PCMSK1 = Pmask1( Fan_chan ) : If PCMSK1 <>0 Then Enable PCINT1
   PCMSK2 = Pmask2( Fan_chan ) : If PCMSK2 <>0 Then Enable PCINT2

   Pci_flag = 0

   Enable Timer2
   Start Timer2

   Do

      If Pci_flag = 1 Then             'ZT[݃tOP̎
         Pci_flag =0
         If Fan_cnt = 0 Then           'ŏ̃pXFݒ
            Timer2 = 0
            Tmr_over_cnt = 0
            Fan_cnt = 1
            Fan_cnt_time = 0.0
         Else                          'Qڈȍ~̃pX
            Tmr_cnt_arg = Timer2
            Tmr_over_cnt_arg = Tmr_over_cnt
            sgl1 = Tmrpass()
            sgl2 = sgl1 - Fan_cnt_time
            If sgl2 > Fan_puls_min_wdth Then
               Fan_cnt = Fan_cnt + 1
               Fan_cnt_time = sgl1
            Endif
         Endif
      Endif

      If Tmr_over_cnt >= Tmr_max Then

         Stop Timer2
         Disable PCINT0
         Disable PCINT1
         Disable Pcint2
         Disable Timer2

         Goto Fan_speed_calc

      Endif
   Loop

Fan_speed_calc:

   Fan_cnt = Fan_cnt-1

   If Fan_cnt <= 0 Then

      Fanspeed = 0

   Else

      X = Fan_cnt * 15000.0
      X = X / Fan_cnt_time
      Fanspeed = Int( X )

   Endif

End Function

'***********************************************************
'Timer2̌oߎԂvZ֐

Function Tmrpass( ) As Single
   'Tmr_over_cnt_arg  :  Timer2 Overflow Count
   'Tmr_cnt_arg       :  Timer2 Count
   'Tmrpass           :  Timer2 passed Time (ms)

   local X As Single
   local Y As Single

   X = Tmr_over_cnt_arg * Tmr_over
   Y = Tmr_cnt_arg * Tmr_cycle
   Tmrpass = X + Y

End Function

'***********************************************************
'ob̃bZ[W󂯎ATu[`

Sub RcvMsg( )

   Local I As Integer
   I = 0
   USB_data = ""

   Do

      While Ischarwaiting() = 1    'VA|[gɕ񂪂ꍇ

         Str1 = Inkey()
         If Str1 = Chr(&H0A) Then
            Call WrtPrm( )
            USB_data = ""
         Else
            USB_data = USB_data + Str1
            I =0
         Endif

      Wend

      If USB_data = "" Then
         Exit Sub
      Else
         Waitms 1
         I = I + 1
      Endif

   Loop Until I >= 10

End sub


'***********************************************************
'ݒ肳Ăt@R萔o͂Tu[`

Sub SndPrm( )

   Local i As Integer
   Local s As String*12

    For i = 1 To 8

      USB_data = "Prm,"
      Select Case i
         Case 1 : s = "Tmin"
         Case 2 : s = "Tmax"
         Case 3 : s = "Tstop"
         Case 4 : s = "Dmin"
         Case 5 : s = "Dmax"
         Case 6 : s = "Dman"
         Case 7 : s = "FanThm"
         Case 8 : s = "FanMan"
      End Select
      USB_data = USB_data + s

      For Fan_chan = 1 To 4
         Select Case i
            Case 1 : Igr1 = Tmin( Fan_chan )
            Case 2 : Igr1 = Tmax( Fan_chan )
            Case 3 : Igr1 = Tstop( Fan_chan )
            Case 4 : Igr1 = Dmin( Fan_chan )
            Case 5 : Igr1 = Dmax( Fan_chan )
            Case 6 : Igr1 = Dman( Fan_chan )
            Case 7 : Igr1 = FanThm( Fan_chan )
            Case 8 : Igr1 = FanMan( Fan_chan )
         End Select
         Str1 = Str( Igr1 )
         USB_data = USB_data + ","
         USB_data = USB_data + Str1
      Next Fan_chan

      Print USB_data

   Next i

   USB_data = "Prm,FanNam"
   For Fan_chan = 1 To 6
       Str1 = Fanname( Fan_chan )
       USB_data = USB_data + ","
       USB_data = USB_data + Str1
   Next Fan_chan
   Print USB_data

   USB_data = "Prm,ThmNam"
   For Thm_chan = 1 To 4
       Str1 = Thmname( Thm_chan )
       USB_data = USB_data + ","
       USB_data = USB_data + Str1
   Next Thm_chan
   Print USB_data

   USB_data = "Prm,Firm," + Firm_Version
   Print USB_data

End Sub

'***********************************************************
'ob̃bZ[Wt@R萔ݒ肷Tu[`

Sub WrtPrm( )

      Igr1 = Split( USB_data , StrArray(1) , "," )

      If StrArray(1) = "SetPrm" Then

         If StrArray(2) = "FanNam" Then
            For Fan_chan = 1 To 6
               Igr2 = Fan_chan + 2
               Str1 = StrArray( Igr2 )
               Fanname( Fan_chan ) = Str1
            Next Fan_chan
         Elseif StrArray(2) = "ThmNam" Then
            For Thm_chan = 1 To 4
               Igr2 = Thm_chan + 2
               Thmname( Thm_chan ) = StrArray( Igr2 )
            Next Thm_chan
         Else
            For Fan_chan = 1 To 4
               Igr2 = Fan_chan + 2
               Str1 = StrArray( Igr2 )
               Igr1 = Val( Str1 )
               Select Case StrArray(2)
                  Case "Tmin"   : Tmin( Fan_chan )   = Igr1
                  Case "Tmax"   : Tmax( Fan_chan )   = Igr1
                  Case "Tstop"  : Tstop( Fan_chan )  = Igr1
                  Case "Dmin"   : Dmin( Fan_chan )   = Igr1
                  Case "Dmax"   : Dmax( Fan_chan )   = Igr1
                  Case "Dman"   : Dman( Fan_chan )   = Igr1
                  Case "FanThm" : FanThm( Fan_chan ) = Igr1
                  Case "FanMan" : FanMan( Fan_chan ) = Igr1
               End Select
            Next Fan_chan
         Endif

      Elseif StrArray(1) = "ExtThm" Then

         For Thm_Chan = 1 To 4
            Igr1 = Thm_Chan + 1
            ExtTemper( Thm_Chan ) = Val( StrArray( Igr1 ) )
         Next i
         Ext_Eff_cnt = Ext_Eff_cnt_max

      Elseif Strarray(1) = "TestOn" Then

         Str1 = Strarray(2)
         Igr1 = Val( Str1 )
         Fan_chan = Igr1
         Call TestMode( Fan_chan )

      Endif

End Sub

'-------------------------------------- Test Mode  ----------------------------------------
'
Sub TestMode( Fan_chan As Byte )

   Local I As integer , J As Integer , K As  Integer , Fchan As Integer

   Fchan = Fan_chan
   Test_cnt = 0      'eXgJEgNA

   USB_data = "TestOn,"
   USB_data = USB_data + Str(Fan_chan)
   Print USB_data

   Do

      USB_data = ""
      While Ischarwaiting() = 1    'VA|[gɕ񂪂ꍇ
         Str1 = Inkey()
         If Str1 <> Chr(&H0A) Then
            USB_data = USB_data + Str1
         Endif
      Wend

      I = Len(USB_data)
      If I > 0 Then

         J = Split(USB_data , Strarray(1) , ",")
         If Strarray(1) = "Test" Then
            Test_cnt = 0             'eXgJEgNA
            Str1 = Strarray(2)
            Igr1 = Val( Str1 )       'FanChannel
            If Fchan = Igr1 Then
               Str1 = Strarray(3)
               Igr1 = Val( Str1 )  'Duty
               Sgl1 = Igr1 * Pmax
               Sgl1 = Sgl1 / 100.0
               Igr1 = Int(Sgl1)
               Pwm_duty(Fan_chan) = Igr1
               Call Set_speed(Fan_chan)
            End If
         Elseif Strarray(1) = "TestOff" Then
            USB_data = "TestOff,"
            USB_data = USB_data + Str(Fan_chan)
            Print USB_data
            Exit Sub
         End If
      End If

      Tmr_max = Tmr_over_cnt_max2
      Fan_tach = Fanspeed(Fan_chan)
      Str1 = Fanname(Fan_chan)  : Str1 = Name_Str( Str1 )
      Str2 = Tach_Str(Fan_tach)
      Sgl1 = Duty_rto(Fan_chan) : Str3 = Duty_Str( Sgl1 )

      USB_data = "Fan," + Str(Fan_chan) + "," + Str1 + "," + Str2 + "," + Str3
      Print USB_data

      Test_cnt = Test_cnt + 1      'eXgJEgCNg

   Loop Until Test_cnt > Test_Max 'eXgJEgɒBTu[`I

End Sub

'-------------------------------------- String Function ----------------------------------------

'***********************************************************
'Uɂt@NV  (Op)

Function Name_Str( Cliped_Str As String ) As String * 6

   Local I As Integer
   Local S As String * 10

   S = Trim( Cliped_Str )
   I = Len( S )
   I = 6 - I
   If I > 0 Then
      Name_Str = S + Space( I )
   Else
      Name_Str = Left( S , 6 )
   Endif

End Function

'***********************************************************
'SEl̕ɂt@NV (]p)

Function Tach_Str( Tach_Igr As Integer )  As String * 4

   Local St1 As String * 6
   Local Ig1 As Integer

   If Tach_Igr =< 0 Then
      Tach_Str = "   0"
   Elseif Tach_Igr > 9999 Then
      Tach_Str = "9999"
   Else
      St1 = Str( Tach_Igr )
      Ig1 = Len( St1 )
      Ig1 = 4 - Ig1
      If Ig1 > 0 Then
         St1 = Space( Ig1 ) + St1
      Endif
      Tach_Str = Left( St1 , 4 )
   Endif

End Function

'*************************************************************************
'𐮐QAP̂SEl̕ɂt@NV (xp)

Function Temp_Str( Temp_Sgl As Single )  As String * 4

   Local St1 As String * 6
   Local Ig1 As Integer

   If Temp_Sgl <= 0.0 Then
      Temp_Str = " 0.0"
   Elseif Temp_Sgl > 99.9 Then
      Temp_Str = "99.9"
   Else
      St1 = Fusing( Temp_Sgl , "##.#" )
      Ig1 = Len( St1 )
      Ig1 = 4 - Ig1
      If Ig1 > 0 Then
         St1 = Space( Ig1 ) + St1
      Endif
      Temp_Str = Left( St1 , 4 )
   Endif

End Function

'*************************************************************************
'𐮐QAP̂SEl̕ɂt@NV (Dutyp)

Function Duty_Str( Duty_Sgl As Single )  As String * 4

   Local St1 As String * 6
   Local Ig1 As Integer

   If Duty_Sgl <= 0.0 Then
      Duty_Str = " 0.0"
   Elseif Duty_Sgl > 99.9 Then
      Duty_Str = "100."
   Else
      St1 = Fusing( Duty_Sgl , "##.#" )
      Ig1 = Len( St1 )
      Ig1 = 4 - Ig1
      If Ig1 > 0 Then
         St1 = Space( Ig1 ) + St1
      Endif
      Duty_Str = Left( St1 , 4 )
   Endif

End Function

'***********************************************************
'PCINT0(Pcint0`7)荞݂̏
'PCINT2(Pcint16`23)荞݂̏
Pci_int:

   Push R27
   Push R26
   PUSH R24
   IN   R24, SREG
   PUSH R24

   Pci_flag = 1

   POP  R24
   !OUT SREG, R24
   POP  R24
   POP  R26
   POP  R27

Return

'***********************************************************
'Timer2荞݂̏
Tmr2_int:

   Push R27
   Push R26
   PUSH R24
   IN   R24, SREG
   PUSH R24

   Incr Tmr_over_cnt

   POP  R24
   !OUT SREG, R24
   POP  R24
   POP  R26
   POP  R27

Return